// third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-params-data.h"
#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/loader/previews_resource_loading_hints.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_PREVIEWS_RESOURCE_LOADING_HINTS_MOJOM_JUMBO_H_
#endif
namespace blink {
namespace mojom {
PreviewsResourceLoadingHints::PreviewsResourceLoadingHints()
    : ukm_source_id(),
      subresources_to_block() {}

PreviewsResourceLoadingHints::PreviewsResourceLoadingHints(
    int64_t ukm_source_id_in,
    std::vector<std::string> subresources_to_block_in)
    : ukm_source_id(std::move(ukm_source_id_in)),
      subresources_to_block(std::move(subresources_to_block_in)) {}

PreviewsResourceLoadingHints::~PreviewsResourceLoadingHints() = default;

void PreviewsResourceLoadingHints::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("ukm_source_id", base::NumberToString(this->ukm_source_id));
  value->BeginArray("subresources_to_block");
  for (const auto& item0 : this->subresources_to_block) {
    value->AppendString(item0);
  }
  value->EndArray();
}

bool PreviewsResourceLoadingHints::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
CompressPublicImagesHints::CompressPublicImagesHints()
    : image_urls() {}

CompressPublicImagesHints::CompressPublicImagesHints(
    std::vector<std::string> image_urls_in)
    : image_urls(std::move(image_urls_in)) {}

CompressPublicImagesHints::~CompressPublicImagesHints() = default;

void CompressPublicImagesHints::AsValueInto(base::trace_event::TracedValue* value) const {
  value->BeginArray("image_urls");
  for (const auto& item0 : this->image_urls) {
    value->AppendString(item0);
  }
  value->EndArray();
}

bool CompressPublicImagesHints::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
LiteVideoHint::LiteVideoHint()
    : kilobytes_to_buffer_before_throttle(),
      target_downlink_bandwidth_kbps(),
      target_downlink_rtt_latency(),
      max_throttling_delay() {}

LiteVideoHint::LiteVideoHint(
    int64_t kilobytes_to_buffer_before_throttle_in,
    int64_t target_downlink_bandwidth_kbps_in,
    ::base::TimeDelta target_downlink_rtt_latency_in,
    ::base::TimeDelta max_throttling_delay_in)
    : kilobytes_to_buffer_before_throttle(std::move(kilobytes_to_buffer_before_throttle_in)),
      target_downlink_bandwidth_kbps(std::move(target_downlink_bandwidth_kbps_in)),
      target_downlink_rtt_latency(std::move(target_downlink_rtt_latency_in)),
      max_throttling_delay(std::move(max_throttling_delay_in)) {}

LiteVideoHint::~LiteVideoHint() = default;

void LiteVideoHint::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("kilobytes_to_buffer_before_throttle", base::NumberToString(this->kilobytes_to_buffer_before_throttle));
  value->SetString("target_downlink_bandwidth_kbps", base::NumberToString(this->target_downlink_bandwidth_kbps));
  value->SetString("target_downlink_rtt_latency", base::trace_event::ValueToString(this->target_downlink_rtt_latency, "<value of type ::base::TimeDelta>"));
  value->SetString("max_throttling_delay", base::trace_event::ValueToString(this->max_throttling_delay, "<value of type ::base::TimeDelta>"));
}

bool LiteVideoHint::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char PreviewsResourceLoadingHintsReceiver::Name_[] = "blink.mojom.PreviewsResourceLoadingHintsReceiver";

PreviewsResourceLoadingHintsReceiverProxy::PreviewsResourceLoadingHintsReceiverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PreviewsResourceLoadingHintsReceiverProxy::SetResourceLoadingHints(
    PreviewsResourceLoadingHintsPtr in_previews_resource_loading_hints) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::PreviewsResourceLoadingHintsReceiver::SetResourceLoadingHints", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      if (in_previews_resource_loading_hints.is_null()) {
        raw_value->SetString("previews_resource_loading_hints", "nullptr");
      } else {
        raw_value->BeginDictionary("previews_resource_loading_hints");
        in_previews_resource_loading_hints->AsValueInto(raw_value);
        raw_value->EndDictionary();
      }
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->previews_resource_loading_hints)::BaseType::BufferWriter
      previews_resource_loading_hints_writer;
  mojo::internal::Serialize<::blink::mojom::PreviewsResourceLoadingHintsDataView>(
      in_previews_resource_loading_hints, buffer, &previews_resource_loading_hints_writer, &serialization_context);
  params->previews_resource_loading_hints.Set(
      previews_resource_loading_hints_writer.is_null() ? nullptr : previews_resource_loading_hints_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->previews_resource_loading_hints.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null previews_resource_loading_hints in PreviewsResourceLoadingHintsReceiver.SetResourceLoadingHints request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PreviewsResourceLoadingHintsReceiver::Name_);
  message.set_method_name("SetResourceLoadingHints");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PreviewsResourceLoadingHintsReceiverProxy::SetCompressPublicImagesHints(
    CompressPublicImagesHintsPtr in_images_hints) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::PreviewsResourceLoadingHintsReceiver::SetCompressPublicImagesHints", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      if (in_images_hints.is_null()) {
        raw_value->SetString("images_hints", "nullptr");
      } else {
        raw_value->BeginDictionary("images_hints");
        in_images_hints->AsValueInto(raw_value);
        raw_value->EndDictionary();
      }
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->images_hints)::BaseType::BufferWriter
      images_hints_writer;
  mojo::internal::Serialize<::blink::mojom::CompressPublicImagesHintsDataView>(
      in_images_hints, buffer, &images_hints_writer, &serialization_context);
  params->images_hints.Set(
      images_hints_writer.is_null() ? nullptr : images_hints_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->images_hints.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null images_hints in PreviewsResourceLoadingHintsReceiver.SetCompressPublicImagesHints request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PreviewsResourceLoadingHintsReceiver::Name_);
  message.set_method_name("SetCompressPublicImagesHints");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PreviewsResourceLoadingHintsReceiverProxy::SetLiteVideoHint(
    LiteVideoHintPtr in_lite_video_hint) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::PreviewsResourceLoadingHintsReceiver::SetLiteVideoHint", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      if (in_lite_video_hint.is_null()) {
        raw_value->SetString("lite_video_hint", "nullptr");
      } else {
        raw_value->BeginDictionary("lite_video_hint");
        in_lite_video_hint->AsValueInto(raw_value);
        raw_value->EndDictionary();
      }
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->lite_video_hint)::BaseType::BufferWriter
      lite_video_hint_writer;
  mojo::internal::Serialize<::blink::mojom::LiteVideoHintDataView>(
      in_lite_video_hint, buffer, &lite_video_hint_writer, &serialization_context);
  params->lite_video_hint.Set(
      lite_video_hint_writer.is_null() ? nullptr : lite_video_hint_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->lite_video_hint.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null lite_video_hint in PreviewsResourceLoadingHintsReceiver.SetLiteVideoHint request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PreviewsResourceLoadingHintsReceiver::Name_);
  message.set_method_name("SetLiteVideoHint");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PreviewsResourceLoadingHintsReceiverProxy::SetBlinkOptimizationGuideHints(
    ::blink::mojom::BlinkOptimizationGuideHintsPtr in_hints) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "blink::mojom::PreviewsResourceLoadingHintsReceiver::SetBlinkOptimizationGuideHints", "input_parameters",
    [&](){
      auto value = std::make_unique<base::trace_event::TracedValue>();
      base::trace_event::TracedValue* raw_value = value.get();
      if (in_hints.is_null()) {
        raw_value->SetString("hints", "nullptr");
      } else {
        raw_value->BeginDictionary("hints");
        in_hints->AsValueInto(raw_value);
        raw_value->EndDictionary();
      }
      return value;
    }());
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->hints)::BaseType::BufferWriter
      hints_writer;
  mojo::internal::Serialize<::blink::mojom::BlinkOptimizationGuideHintsDataView>(
      in_hints, buffer, &hints_writer, &serialization_context);
  params->hints.Set(
      hints_writer.is_null() ? nullptr : hints_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->hints.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null hints in PreviewsResourceLoadingHintsReceiver.SetBlinkOptimizationGuideHints request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PreviewsResourceLoadingHintsReceiver::Name_);
  message.set_method_name("SetBlinkOptimizationGuideHints");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void PreviewsResourceLoadingHintsReceiverProxy::StopThrottlingMediaRequests(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "blink::mojom::PreviewsResourceLoadingHintsReceiver::StopThrottlingMediaRequests");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::blink::mojom::internal::PreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PreviewsResourceLoadingHintsReceiver::Name_);
  message.set_method_name("StopThrottlingMediaRequests");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool PreviewsResourceLoadingHintsReceiverStubDispatch::Accept(
    PreviewsResourceLoadingHintsReceiver* impl,
    mojo::Message* message) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  switch (message->header()->name) {
    case internal::kPreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetResourceLoadingHints",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetResourceLoadingHints");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Params_Data* params =
          reinterpret_cast<internal::PreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PreviewsResourceLoadingHintsPtr p_previews_resource_loading_hints{};
      PreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadPreviewsResourceLoadingHints(&p_previews_resource_loading_hints))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PreviewsResourceLoadingHintsReceiver::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetResourceLoadingHints(
std::move(p_previews_resource_loading_hints));
      return true;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetCompressPublicImagesHints",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetCompressPublicImagesHints");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Params_Data* params =
          reinterpret_cast<internal::PreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      CompressPublicImagesHintsPtr p_images_hints{};
      PreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadImagesHints(&p_images_hints))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PreviewsResourceLoadingHintsReceiver::Name_, 1, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetCompressPublicImagesHints(
std::move(p_images_hints));
      return true;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetLiteVideoHint",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetLiteVideoHint");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Params_Data* params =
          reinterpret_cast<internal::PreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      LiteVideoHintPtr p_lite_video_hint{};
      PreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadLiteVideoHint(&p_lite_video_hint))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PreviewsResourceLoadingHintsReceiver::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetLiteVideoHint(
std::move(p_lite_video_hint));
      return true;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetBlinkOptimizationGuideHints",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::SetBlinkOptimizationGuideHints");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Params_Data* params =
          reinterpret_cast<internal::PreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      ::blink::mojom::BlinkOptimizationGuideHintsPtr p_hints{};
      PreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_ParamsDataView input_data_view(params, &serialization_context);
      
      if (success && !input_data_view.ReadHints(&p_hints))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PreviewsResourceLoadingHintsReceiver::Name_, 3, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetBlinkOptimizationGuideHints(
std::move(p_hints));
      return true;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      TRACE_EVENT1(
          "mojom",
          "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::StopThrottlingMediaRequests",
          "message", message->name());
#endif
      static constexpr uint32_t kMessageHash = base::MD5Hash32Constexpr(
              "(Impl)blink::mojom::PreviewsResourceLoadingHintsReceiver::StopThrottlingMediaRequests");
      base::TaskAnnotator::ScopedSetIpcHash scoped_ipc_hash(kMessageHash);

      DCHECK(message->is_serialized());
      internal::PreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Params_Data* params =
          reinterpret_cast<internal::PreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Params_Data*>(
              message->mutable_payload());
      
      bool success = true;
      PreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            PreviewsResourceLoadingHintsReceiver::Name_, 4, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->StopThrottlingMediaRequests();
      return true;
    }
  }
  return false;
}

// static
bool PreviewsResourceLoadingHintsReceiverStubDispatch::AcceptWithResponder(
    PreviewsResourceLoadingHintsReceiver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  mojo::internal::MessageDispatchContext dispatch_context(message);
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  const bool message_is_sync = message->has_flag(mojo::Message::kFlagIsSync);
  const uint64_t request_id = message->request_id();
  ALLOW_UNUSED_LOCAL(message_is_sync);
  ALLOW_UNUSED_LOCAL(request_id);
  switch (message->header()->name) {
    case internal::kPreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Name: {
      break;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Name: {
      break;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Name: {
      break;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Name: {
      break;
    }
    case internal::kPreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Name: {
      break;
    }
  }
  return false;
}


static const mojo::internal::GenericValidationInfo kPreviewsResourceLoadingHintsReceiverValidationInfo[] = {
    {&internal::PreviewsResourceLoadingHintsReceiver_SetResourceLoadingHints_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PreviewsResourceLoadingHintsReceiver_SetCompressPublicImagesHints_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PreviewsResourceLoadingHintsReceiver_SetLiteVideoHint_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PreviewsResourceLoadingHintsReceiver_SetBlinkOptimizationGuideHints_Params_Data::Validate,
     nullptr /* no response */},
    {&internal::PreviewsResourceLoadingHintsReceiver_StopThrottlingMediaRequests_Params_Data::Validate,
     nullptr /* no response */},
};

bool PreviewsResourceLoadingHintsReceiverRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::blink::mojom::PreviewsResourceLoadingHintsReceiver::Name_;
  return mojo::internal::ValidateRequestGenericPacked(message, name, kPreviewsResourceLoadingHintsReceiverValidationInfo);
}

}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::PreviewsResourceLoadingHints::DataView, ::blink::mojom::PreviewsResourceLoadingHintsPtr>::Read(
    ::blink::mojom::PreviewsResourceLoadingHints::DataView input,
    ::blink::mojom::PreviewsResourceLoadingHintsPtr* output) {
  bool success = true;
  ::blink::mojom::PreviewsResourceLoadingHintsPtr result(::blink::mojom::PreviewsResourceLoadingHints::New());
  
      if (success)
        result->ukm_source_id = input.ukm_source_id();
      if (success && !input.ReadSubresourcesToBlock(&result->subresources_to_block))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::CompressPublicImagesHints::DataView, ::blink::mojom::CompressPublicImagesHintsPtr>::Read(
    ::blink::mojom::CompressPublicImagesHints::DataView input,
    ::blink::mojom::CompressPublicImagesHintsPtr* output) {
  bool success = true;
  ::blink::mojom::CompressPublicImagesHintsPtr result(::blink::mojom::CompressPublicImagesHints::New());
  
      if (success && !input.ReadImageUrls(&result->image_urls))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::LiteVideoHint::DataView, ::blink::mojom::LiteVideoHintPtr>::Read(
    ::blink::mojom::LiteVideoHint::DataView input,
    ::blink::mojom::LiteVideoHintPtr* output) {
  bool success = true;
  ::blink::mojom::LiteVideoHintPtr result(::blink::mojom::LiteVideoHint::New());
  
      if (success)
        result->kilobytes_to_buffer_before_throttle = input.kilobytes_to_buffer_before_throttle();
      if (success)
        result->target_downlink_bandwidth_kbps = input.target_downlink_bandwidth_kbps();
      if (success && !input.ReadTargetDownlinkRttLatency(&result->target_downlink_rtt_latency))
        success = false;
      if (success && !input.ReadMaxThrottlingDelay(&result->max_throttling_delay))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif