// third_party/blink/public/mojom/notifications/notification.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "third_party/blink/public/mojom/notifications/notification.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/common/task_annotator.h"
#include "base/trace_event/trace_conversion_helper.h"
#include "base/trace_event/traced_value.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "third_party/blink/public/mojom/notifications/notification.mojom-params-data.h"
#include "third_party/blink/public/mojom/notifications/notification.mojom-shared-message-ids.h"

#include "third_party/blink/public/mojom/notifications/notification.mojom-import-headers.h"


#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_NOTIFICATIONS_NOTIFICATION_MOJOM_JUMBO_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_NOTIFICATIONS_NOTIFICATION_MOJOM_JUMBO_H_
#endif
namespace blink {
namespace mojom {
constexpr uint64_t NotificationData::kMaximumDeveloperDataSize;
NotificationAction::NotificationAction()
    : type(),
      action(),
      title(),
      icon(),
      placeholder() {}

NotificationAction::NotificationAction(
    NotificationActionType type_in,
    const std::string& action_in,
    const ::base::string16& title_in,
    const ::GURL& icon_in,
    const base::Optional<::base::string16>& placeholder_in)
    : type(std::move(type_in)),
      action(std::move(action_in)),
      title(std::move(title_in)),
      icon(std::move(icon_in)),
      placeholder(std::move(placeholder_in)) {}

NotificationAction::~NotificationAction() = default;

void NotificationAction::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("type", base::trace_event::ValueToString(this->type));
  value->SetString("action", this->action);
  value->SetString("title", base::trace_event::ValueToString(this->title, "<value of type const ::base::string16&>"));
  value->SetString("icon", base::trace_event::ValueToString(this->icon, "<value of type const ::GURL&>"));
  value->SetString("placeholder", base::trace_event::ValueToString(this->placeholder, "<value of type const base::Optional<::base::string16>&>"));
}

bool NotificationAction::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
NotificationData::NotificationData()
    : title(),
      direction(NotificationDirection::LEFT_TO_RIGHT),
      lang(),
      body(),
      tag(),
      image(),
      icon(),
      badge(),
      vibration_pattern(),
      timestamp(0),
      renotify(false),
      silent(false),
      require_interaction(false),
      data(),
      actions(),
      show_trigger_timestamp() {}

NotificationData::NotificationData(
    const ::base::string16& title_in,
    NotificationDirection direction_in,
    const base::Optional<std::string>& lang_in,
    const ::base::string16& body_in,
    const std::string& tag_in,
    const ::GURL& image_in,
    const ::GURL& icon_in,
    const ::GURL& badge_in,
    base::Optional<std::vector<int32_t>> vibration_pattern_in,
    double timestamp_in,
    bool renotify_in,
    bool silent_in,
    bool require_interaction_in,
    base::Optional<std::vector<uint8_t>> data_in,
    base::Optional<std::vector<NotificationActionPtr>> actions_in,
    base::Optional<::base::Time> show_trigger_timestamp_in)
    : title(std::move(title_in)),
      direction(std::move(direction_in)),
      lang(std::move(lang_in)),
      body(std::move(body_in)),
      tag(std::move(tag_in)),
      image(std::move(image_in)),
      icon(std::move(icon_in)),
      badge(std::move(badge_in)),
      vibration_pattern(std::move(vibration_pattern_in)),
      timestamp(std::move(timestamp_in)),
      renotify(std::move(renotify_in)),
      silent(std::move(silent_in)),
      require_interaction(std::move(require_interaction_in)),
      data(std::move(data_in)),
      actions(std::move(actions_in)),
      show_trigger_timestamp(std::move(show_trigger_timestamp_in)) {}

NotificationData::~NotificationData() = default;

void NotificationData::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("title", base::trace_event::ValueToString(this->title, "<value of type const ::base::string16&>"));
  value->SetString("direction", base::trace_event::ValueToString(this->direction));
  if (this->lang.has_value()) {
    value->SetString("lang", this->lang.value());
  } else {
    value->SetString("lang", "base::nullopt");
  }
  value->SetString("body", base::trace_event::ValueToString(this->body, "<value of type const ::base::string16&>"));
  value->SetString("tag", this->tag);
  value->SetString("image", base::trace_event::ValueToString(this->image, "<value of type const ::GURL&>"));
  value->SetString("icon", base::trace_event::ValueToString(this->icon, "<value of type const ::GURL&>"));
  value->SetString("badge", base::trace_event::ValueToString(this->badge, "<value of type const ::GURL&>"));
  if (this->vibration_pattern.has_value()) {
    value->BeginArray("vibration_pattern");
    for (const auto& item0 : this->vibration_pattern.value()) {
      value->AppendInteger(item0);
    }
    value->EndArray();
  } else {
    value->SetString("vibration_pattern", "base::nullopt");
  }
  value->SetDouble("timestamp", this->timestamp);
  value->SetBoolean("renotify", this->renotify);
  value->SetBoolean("silent", this->silent);
  value->SetBoolean("require_interaction", this->require_interaction);
  if (this->data.has_value()) {
    value->BeginArray("data");
    for (const auto& item0 : this->data.value()) {
      value->AppendInteger(item0);
    }
    value->EndArray();
  } else {
    value->SetString("data", "base::nullopt");
  }
  if (this->actions.has_value()) {
    value->BeginArray("actions");
    for (const auto& item0 : this->actions.value()) {
      if (item0.is_null()) {
        value->AppendString("nullptr");
      } else {
        value->BeginDictionary();
        item0->AsValueInto(value);
        value->EndDictionary();
      }
    }
    value->EndArray();
  } else {
    value->SetString("actions", "base::nullopt");
  }
  value->SetString("show_trigger_timestamp", base::trace_event::ValueToString(this->show_trigger_timestamp, "<value of type base::Optional<::base::Time>>"));
}

bool NotificationData::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
NotificationResources::NotificationResources()
    : image(),
      icon(),
      badge(),
      action_icons() {}

NotificationResources::NotificationResources(
    const ::SkBitmap& image_in,
    const ::SkBitmap& icon_in,
    const ::SkBitmap& badge_in,
    base::Optional<std::vector<::SkBitmap>> action_icons_in)
    : image(std::move(image_in)),
      icon(std::move(icon_in)),
      badge(std::move(badge_in)),
      action_icons(std::move(action_icons_in)) {}

NotificationResources::~NotificationResources() = default;

void NotificationResources::AsValueInto(base::trace_event::TracedValue* value) const {
  value->SetString("image", base::trace_event::ValueToString(this->image, "<value of type const ::SkBitmap&>"));
  value->SetString("icon", base::trace_event::ValueToString(this->icon, "<value of type const ::SkBitmap&>"));
  value->SetString("badge", base::trace_event::ValueToString(this->badge, "<value of type const ::SkBitmap&>"));
  if (this->action_icons.has_value()) {
    value->BeginArray("action_icons");
    for (const auto& item0 : this->action_icons.value()) {
      value->AppendString(base::trace_event::ValueToString(item0, "<value of type const ::SkBitmap&>"));
    }
    value->EndArray();
  } else {
    value->SetString("action_icons", "base::nullopt");
  }
}

bool NotificationResources::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace blink

namespace mojo {


// static
bool StructTraits<::blink::mojom::NotificationAction::DataView, ::blink::mojom::NotificationActionPtr>::Read(
    ::blink::mojom::NotificationAction::DataView input,
    ::blink::mojom::NotificationActionPtr* output) {
  bool success = true;
  ::blink::mojom::NotificationActionPtr result(::blink::mojom::NotificationAction::New());
  
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success && !input.ReadAction(&result->action))
        success = false;
      if (success && !input.ReadTitle(&result->title))
        success = false;
      if (success && !input.ReadIcon(&result->icon))
        success = false;
      if (success && !input.ReadPlaceholder(&result->placeholder))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::NotificationData::DataView, ::blink::mojom::NotificationDataPtr>::Read(
    ::blink::mojom::NotificationData::DataView input,
    ::blink::mojom::NotificationDataPtr* output) {
  bool success = true;
  ::blink::mojom::NotificationDataPtr result(::blink::mojom::NotificationData::New());
  
      if (success && !input.ReadTitle(&result->title))
        success = false;
      if (success && !input.ReadDirection(&result->direction))
        success = false;
      if (success && !input.ReadLang(&result->lang))
        success = false;
      if (success && !input.ReadBody(&result->body))
        success = false;
      if (success && !input.ReadTag(&result->tag))
        success = false;
      if (success && !input.ReadImage(&result->image))
        success = false;
      if (success && !input.ReadIcon(&result->icon))
        success = false;
      if (success && !input.ReadBadge(&result->badge))
        success = false;
      if (success && !input.ReadVibrationPattern(&result->vibration_pattern))
        success = false;
      if (success)
        result->timestamp = input.timestamp();
      if (success)
        result->renotify = input.renotify();
      if (success)
        result->silent = input.silent();
      if (success)
        result->require_interaction = input.require_interaction();
      if (success && !input.ReadData(&result->data))
        success = false;
      if (success && !input.ReadActions(&result->actions))
        success = false;
      if (success && !input.ReadShowTriggerTimestamp(&result->show_trigger_timestamp))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::blink::mojom::NotificationResources::DataView, ::blink::mojom::NotificationResourcesPtr>::Read(
    ::blink::mojom::NotificationResources::DataView input,
    ::blink::mojom::NotificationResourcesPtr* output) {
  bool success = true;
  ::blink::mojom::NotificationResourcesPtr result(::blink::mojom::NotificationResources::New());
  
      if (success && !input.ReadImage(&result->image))
        success = false;
      if (success && !input.ReadIcon(&result->icon))
        success = false;
      if (success && !input.ReadBadge(&result->badge))
        success = false;
      if (success && !input.ReadActionIcons(&result->action_icons))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#endif