// ui/gfx/mojom/presentation_feedback.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_GFX_MOJOM_PRESENTATION_FEEDBACK_MOJOM_BLINK_H_
#define UI_GFX_MOJOM_PRESENTATION_FEEDBACK_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "ui/gfx/mojom/presentation_feedback.mojom-shared.h"
#include "ui/gfx/mojom/presentation_feedback.mojom-blink-forward.h"
#include "mojo/public/mojom/base/time.mojom-blink.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"




#include "ui/gfx/mojom/presentation_feedback_mojom_traits.h"



// Forward-declare for |AsValueInto| so that we do not have to import the
// corresponding header.
namespace base {
namespace trace_event {
class TracedValue;
}  // namespace trace_event
}  // namespace base


namespace gfx {
namespace mojom {
namespace blink {








class  PresentationFeedback {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<PresentationFeedback, T>::value>;
  using DataView = PresentationFeedbackDataView;
  using Data_ = internal::PresentationFeedback_Data;

  template <typename... Args>
  static PresentationFeedbackPtr New(Args&&... args) {
    return PresentationFeedbackPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static PresentationFeedbackPtr From(const U& u) {
    return mojo::TypeConverter<PresentationFeedbackPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, PresentationFeedback>::Convert(*this);
  }


  PresentationFeedback();

  PresentationFeedback(
      ::base::TimeTicks timestamp,
      ::base::TimeDelta interval,
      uint32_t flags,
      ::base::TimeTicks available_timestamp,
      ::base::TimeTicks ready_timestamp,
      ::base::TimeTicks latch_timestamp);

  ~PresentationFeedback();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = PresentationFeedbackPtr>
  PresentationFeedbackPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, PresentationFeedback::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        PresentationFeedback::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        PresentationFeedback::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::PresentationFeedback_UnserializedMessageContext<
            UserType, PresentationFeedback::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<PresentationFeedback::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return PresentationFeedback::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::PresentationFeedback_UnserializedMessageContext<
            UserType, PresentationFeedback::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<PresentationFeedback::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  
  ::base::TimeTicks timestamp;
  
  ::base::TimeDelta interval;
  
  uint32_t flags;
  
  ::base::TimeTicks available_timestamp;
  
  ::base::TimeTicks ready_timestamp;
  
  ::base::TimeTicks latch_timestamp;

  // Write this structure into |value|. The members are represented as a
  // dictionary |member name|: |member value|. This method does not deal with
  // the dictionary name. The caller is responsible for not calling
  // |AsValueInto| when |value| expects array items (see Array/Dictionary
  // methods of |base::trace_event::TracedValue|).
  //
  // |value| The TracedValue to be written into.
  //
  // Example uses:
  //
  //   // |my_var1, my_var2| are variables with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   value->BeginDictionary("my_var1");
  //   my_var1.AsValueInto(value.get());
  //   value->EndDictionary();
  //   value->BeginDictionary("my_var2");
  //   my_var2.AsValueInto(value.get());
  //   value->EndDictionary();
  //
  //   // |my_var| is a variable with defined |AsValueInto| method.
  //   auto value = std::make_unique<base::trace_event::TracedValue>();
  //   my_var.AsValueInto(value.get());
  //   TRACE_EVENT1("test", "test", "my_var", std::move(value));
  //
  // Calling |AsValueInto| on two objects without opening and closing a
  // dictionary for each object is theoretically possible, but strongly
  // discouraged due to potential name collisions:
  //
  //   struct A {
  //     int foo;
  //   };
  //   struct B {
  //     int bar;
  //   };
  //   struct C {
  //     int foo;
  //     int bar;
  //   };
  //   auto value1 = std::make_unique<base::trace_event::TracedValue>();
  //   auto value2 = std::make_unique<base::trace_event::TracedValue>();
  //   A a;
  //   B b;
  //   C c;
  //   // value1 and value2 will be filled with the same information:
  //   a.AsValueInto(value1);
  //   b.AsValueInto(value1);
  //   c.AsValueInto(value2);
  void AsValueInto(base::trace_event::TracedValue* value) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, PresentationFeedback::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, PresentationFeedback::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, PresentationFeedback::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, PresentationFeedback::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
PresentationFeedbackPtr PresentationFeedback::Clone() const {
  return New(
      mojo::Clone(timestamp),
      mojo::Clone(interval),
      mojo::Clone(flags),
      mojo::Clone(available_timestamp),
      mojo::Clone(ready_timestamp),
      mojo::Clone(latch_timestamp)
  );
}

template <typename T, PresentationFeedback::EnableIfSame<T>*>
bool PresentationFeedback::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->timestamp, other_struct.timestamp))
    return false;
  if (!mojo::Equals(this->interval, other_struct.interval))
    return false;
  if (!mojo::Equals(this->flags, other_struct.flags))
    return false;
  if (!mojo::Equals(this->available_timestamp, other_struct.available_timestamp))
    return false;
  if (!mojo::Equals(this->ready_timestamp, other_struct.ready_timestamp))
    return false;
  if (!mojo::Equals(this->latch_timestamp, other_struct.latch_timestamp))
    return false;
  return true;
}

template <typename T, PresentationFeedback::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (std::less<>{}(lhs.timestamp, rhs.timestamp))
    return true;
  if (std::less<>{}(rhs.timestamp, lhs.timestamp))
    return false;
  if (std::less<>{}(lhs.interval, rhs.interval))
    return true;
  if (std::less<>{}(rhs.interval, lhs.interval))
    return false;
  if (std::less<>{}(lhs.flags, rhs.flags))
    return true;
  if (std::less<>{}(rhs.flags, lhs.flags))
    return false;
  if (std::less<>{}(lhs.available_timestamp, rhs.available_timestamp))
    return true;
  if (std::less<>{}(rhs.available_timestamp, lhs.available_timestamp))
    return false;
  if (std::less<>{}(lhs.ready_timestamp, rhs.ready_timestamp))
    return true;
  if (std::less<>{}(rhs.ready_timestamp, lhs.ready_timestamp))
    return false;
  if (std::less<>{}(lhs.latch_timestamp, rhs.latch_timestamp))
    return true;
  if (std::less<>{}(rhs.latch_timestamp, lhs.latch_timestamp))
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace gfx

namespace mojo {


template <>
struct  StructTraits<::gfx::mojom::blink::PresentationFeedback::DataView,
                                         ::gfx::mojom::blink::PresentationFeedbackPtr> {
  static bool IsNull(const ::gfx::mojom::blink::PresentationFeedbackPtr& input) { return !input; }
  static void SetToNull(::gfx::mojom::blink::PresentationFeedbackPtr* output) { output->reset(); }

  static const decltype(::gfx::mojom::blink::PresentationFeedback::timestamp)& timestamp(
      const ::gfx::mojom::blink::PresentationFeedbackPtr& input) {
    return input->timestamp;
  }

  static const decltype(::gfx::mojom::blink::PresentationFeedback::interval)& interval(
      const ::gfx::mojom::blink::PresentationFeedbackPtr& input) {
    return input->interval;
  }

  static decltype(::gfx::mojom::blink::PresentationFeedback::flags) flags(
      const ::gfx::mojom::blink::PresentationFeedbackPtr& input) {
    return input->flags;
  }

  static const decltype(::gfx::mojom::blink::PresentationFeedback::available_timestamp)& available_timestamp(
      const ::gfx::mojom::blink::PresentationFeedbackPtr& input) {
    return input->available_timestamp;
  }

  static const decltype(::gfx::mojom::blink::PresentationFeedback::ready_timestamp)& ready_timestamp(
      const ::gfx::mojom::blink::PresentationFeedbackPtr& input) {
    return input->ready_timestamp;
  }

  static const decltype(::gfx::mojom::blink::PresentationFeedback::latch_timestamp)& latch_timestamp(
      const ::gfx::mojom::blink::PresentationFeedbackPtr& input) {
    return input->latch_timestamp;
  }

  static bool Read(::gfx::mojom::blink::PresentationFeedback::DataView input, ::gfx::mojom::blink::PresentationFeedbackPtr* output);
};

}  // namespace mojo

#endif  // UI_GFX_MOJOM_PRESENTATION_FEEDBACK_MOJOM_BLINK_H_